/****************************************************************************
 File: openobj.h

 (C) Copyright 1992 by GO Corporation, All Rights Reserved.

 You may use this Sample Code any way you please provided you 
 do not resell the code and that this notice (including the above 
 copyright notice) is reproduced on all copies.  THIS SAMPLE CODE 
 IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, AND GO CORPORATION 
 EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES, INCLUDING BUT NOT 
 LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE. IN NO EVENT WILL GO CORPORATION BE LIABLE TO YOU 
 FOR ANY CONSEQUENTIAL,INCIDENTAL,OR INDIRECT DAMAGES ARISING OUT OF 
 THE USE OR INABILITY TO USE THIS SAMPLE CODE.

 $Revision:   1.19  $
   $Author:   kcatlin  $
     $Date:   31 Jan 1992 12:20:16  $

 This file contains the API definition for clsTestOpenObject.
 clsTestOpenObject inherits from clsOpenServiceObject.
 Provides a template for a multi-user service's open object class.

****************************************************************************/
#ifndef OPENOBJ_INCLUDED
#define OPENOBJ_INCLUDED

#ifndef OPENSERV_INCLUDED
#include <openserv.h>
#endif

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *					Common #defines and typedefs						   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                  				Messages        		               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/****************************************************************************
 msgNew						takes P_TEST_OPEN_OBJECT_NEW, returns STATUS
	category: class message
	Creates a new test open object instance.
*/

typedef struct TEST_OPEN_OBJECT_NEW_ONLY {
    U32                     unused1;
    U32                     unused2;
    U32                     unused3;
} TEST_OPEN_OBJECT_NEW_ONLY, *P_TEST_OPEN_OBJECT_NEW_ONLY;

#define testOpenObjectNewFields 	\
	openServiceObjectNewFields      \
    TEST_OPEN_OBJECT_NEW_ONLY       testOpenObject;

typedef struct TEST_OPEN_OBJECT_NEW {
    testOpenObjectNewFields
} TEST_OPEN_OBJECT_NEW, *P_TEST_OPEN_OBJECT_NEW;


/****************************************************************************
 msgNewDefaults				takes P_TEST_OPEN_OBJECT_NEW, returns STATUS
	category: class message
	Set defaults:

*/


						/* Your messages here! */


#endif  // OPENOBJ_INCLUDED



